#include <stdio.h>
#include <conio.h>
#include <time.h>
#include <dos.h>

#define ESC   27

typedef void interrupt (*P_PRER) (void);//typ ukazatel na obsluhu prerus.

P_PRER stara_adresa;			//promenna pro uschovu stare adresy

volatile unsigned int vteriny = 0;

void interrupt casovac(void)		//obsluha preruseni casovace
{
  static unsigned int tiky = 0;

  tiky++;
  if (tiky == 18)
  {
    vteriny++;
    tiky = 0;
  }

  (*stara_adresa)();			//volani puvodni obsluhy preruseni
}

void main(void)
{
  unsigned int sekundy = 1;

  stara_adresa = getvect(0x1C);		//zjisteni stare adresy z prerusovaciho vektoru
  setvect(0x1C, casovac);		//zapis adresy nasi obsluhy do prerusovaciho vektoru
  clrscr();
  while (1) {
    if (sekundy != vteriny) {
      sekundy = vteriny;
      switch (sekundy % 9) {
	case 0:   printf("Napoustim vodu...\n"); break;
	case 2:   printf("Macham vpravo...\n"); break;
	case 3:   printf("Macham vlevo...\n"); break;
	case 4:   printf("Macham vpravo...\n"); break;
	case 5:   printf("Macham vlevo...\n"); break;
	case 6:   printf("Vypoustim vodu...\n"); break;
      }
      sound(880); delay(50); nosound();
    }
    if (kbhit() != 0)
      if (getch() == ESC)
	break;
  }

  setvect(0x1C, stara_adresa);
}