#include <stdio.h>
#include <conio.h>
#include <time.h>
#include <dos.h>

#define ESC   27

typedef void interrupt (*P_PRER) (void);//typ ukazatel na obsluhu prerus.

P_PRER stara_adresa;			//promenna pro uschovu stare adresy

volatile unsigned int vteriny = 0, tiky = 0;

void interrupt casovac(void)		//obsluha preruseni casovace
{
  tiky++;
  if (tiky == 10) {
    vteriny++;
    tiky = 0;
  }

  (*stara_adresa)();			//volani puvodni obsluhy preruseni
}

void main(void)
{
  unsigned int sekundy = 1;

  stara_adresa = getvect(0x1C);		//zjisteni stare adresy z prerusovaciho vektoru
  setvect(0x1C, casovac);		//zapis adresy nasi obsluhy do prerusovaciho vektoru

  outportb(0x43,0x34);
  outportb(0x40,0x2E);
  outportb(0x40,0x3A);

  clrscr();
  while (1) {
    if (sekundy != vteriny) {
      sekundy = vteriny;
      clrscr();
      switch (sekundy % 4) {
	case 0:   printf("/ %d", sekundy/8); break;
	case 1:   printf("| %d", sekundy/8); break;
	case 2:   printf("\\ %d", sekundy/8); break;
	case 3:   printf("- %d", sekundy/8); break;
      }
    }
    if (kbhit() != 0)
      if (getch() == ESC)
	break;
  }

  outportb(0x43,0x34);
  outportb(0x40,0xFF);
  outportb(0x40,0xFF);
  setvect(0x1C, stara_adresa);
}